#ifndef TL_PREVIEW
#define TL_PREVIEW

#include "app.h"


class PreviewCanvas;
class PreviewFrame : public wxFrame
{
public:
	PreviewFrame(wxWindow *parent);
	void OnPaint(wxPaintEvent& event);
	void MenuSaveProject(wxCommandEvent&);
	void MenuLoadProject(wxCommandEvent&);
	void MenuSaveModel(wxCommandEvent&);
	void MenuLoadModel(wxCommandEvent&);
	void MenuLoadTexture(wxCommandEvent&);
	void MenuInfomation(wxCommandEvent& event);
	void SliderChanged(wxScrollEvent& event);

	void NewClip(wxCommandEvent& event);
	void DeleteClip(wxCommandEvent& event);

	void AddEntry(wxCommandEvent& event);
	void RemoveEntry(wxCommandEvent& event);
	void EntryClicked(wxCommandEvent& event);
	void ChangeEntryName(wxCommandEvent& event);
	void ChangeEntryFrame(wxCommandEvent& event);
	void ChoiceClip(wxCommandEvent& event);

	void ReloadModel(wxCommandEvent& event);
	void InvertVCoord(wxCommandEvent& event);

	void RefreshTimeSlider();
	void RefreshClipChoice();
	void RefreshModelList();


	PreviewCanvas *canvas;
	wxPanel *right_panel;
	wxSlider *timeline_slider;
	wxChoice *clip_choice;
	wxListBox *model_listbox;
	wxTextCtrl *timeline_text;
	wxTextCtrl *log_window;
	wxTextCtrl *entry_name;
	wxTextCtrl *entry_frame;
	wxTextCtrl *entry_path;

private:
	DECLARE_EVENT_TABLE()
};


#endif
