#ifndef GL_KANJI_INCLUDE
#define GL_KANJI_INCLUDE

#include <vector>


namespace ist {
namespace gl {


class Kanji
{
public:
	enum Code { SJIS, EUC, JIS };

	Kanji(Code _code=SJIS) { code=_code; }
	Kanji(const char *filename, Code _code=SJIS) { code=_code; load(filename); }

	void print(int x, int y, const char *str);

	void setCode(Code _code) { code=_code; }
	int getFontSize() { return font_size; }
	bool load(const char *filename);

	static void sjis2jis(unsigned char &c1, unsigned char &c2);
	static void euc2jis(unsigned char &c1, unsigned char &c2);

protected:
	const unsigned char* getChar(int index) { return &data[index*char_byte]; }

	int font_size, char_byte, max_index;
	std::vector<unsigned char> data;
	Code code;

};


} //gl
} //ist

#endif
