#ifndef GL_POLYGON_MODEL_INCLUDE
#define GL_POLYGON_MODEL_INCLUDE


#include <vector>
#include "base_polygon_model.h"

namespace ist {
namespace gl {


class ARB_vertex_buffer_object
{
public:
	static bool isSupported();
	static bool isEnabled();
	static void enable() { enable_=true; }
	static void disable() { enable_=false; }

private:
	static bool is_supported, enable_;

	ARB_vertex_buffer_object();
	~ARB_vertex_buffer_object();
};



class PolygonChunc : public BasePolygonChunc
{
public:
	PolygonChunc();
	~PolygonChunc();

	void draw() const;
	void setup();
	const std::string& getTypeString() const;

protected:
	std::vector<float> vertex_array;
	unsigned int vbo_id;
};


typedef TPolygonModel<PolygonChunc> PolygonModel;


} //gl
} //ist

#endif
