#ifndef IST_FRAME_INCLUDE
#define IST_FRAME_INCLUDE


#if defined(_WIN32) && !defined(USE_SDL) && !defined(__MINGW32__)
#	define USE_WINAPI
#	include <windows.h>
#	define main fw_main
#else
#	ifndef USE_SDL
#		define USE_SDL
#	endif
#	include <SDL.h>
#endif


namespace ist {
namespace fw {

	enum {
#ifdef USE_WINAPI
		KEY_RETURN	= VK_RETURN,
		KEY_SPACE	= VK_SPACE,
		KEY_RIGHT	= VK_RIGHT,
		KEY_LEFT	= VK_LEFT,
		KEY_UP		= VK_UP,
		KEY_DOWN	= VK_DOWN,
		KEY_A = 65,
		KEY_B = 66,
		KEY_C = 67,
		KEY_D = 68,
		KEY_E = 69,
		KEY_F = 70,
		KEY_G = 71,
		KEY_H = 72,
		KEY_I = 73,
		KEY_J = 74,
		KEY_K = 75,
		KEY_L = 76,
		KEY_M = 77,
		KEY_N = 78,
		KEY_O = 79,
		KEY_P = 80,
		KEY_Q = 81,
		KEY_R = 82,
		KEY_S = 83,
		KEY_T = 84,
		KEY_U = 85,
		KEY_V = 86,
		KEY_W = 87,
		KEY_X = 88,
		KEY_Y = 89,
		KEY_Z = 90,
#endif
#ifdef USE_SDL
		KEY_RETURN	= SDLK_RETURN,
		KEY_SPACE	= SDLK_SPACE,
		KEY_RIGHT	= SDLK_RIGHT,
		KEY_LEFT	= SDLK_LEFT,
		KEY_UP		= SDLK_UP,
		KEY_DOWN	= SDLK_DOWN,
		KEY_A = 97,
		KEY_B = 98,
		KEY_C = 99,
		KEY_D = 100,
		KEY_E = 101,
		KEY_F = 102,
		KEY_G = 103,
		KEY_H = 104,
		KEY_I = 105,
		KEY_J = 106,
		KEY_K = 107,
		KEY_L = 108,
		KEY_M = 109,
		KEY_N = 110,
		KEY_O = 111,
		KEY_P = 112,
		KEY_Q = 113,
		KEY_R = 114,
		KEY_S = 115,
		KEY_T = 116,
		KEY_U = 117,
		KEY_V = 118,
		KEY_W = 119,
		KEY_X = 120,
		KEY_Y = 121,
		KEY_Z = 122,
#endif
	};

	enum {
		MOUSE_LEFT		= 1,
		MOUSE_MIDDLE	= 2,
		MOUSE_RIGHT		= 4
	};

	enum {
		WM_FULLSCREEN	= 1,
		WM_OPENGL		= 2,
	//	WM_DIRECTX		= 4,
	};

	void Init();
	void Quit();
	bool OpenWindow(int width, int height, int flag);

	unsigned int GetTicks();
	bool  GetKeyState(short key);
	bool  SetJoystickID(int id);
	bool  GetJoystickButton(int button);
	short GetJoystickButton();
	short GetJoystickAxis(int axis);
	int   GetMouseState(int *x, int *y);

	void SwapBuffers();
	int ClearEvent();
//	int PopEvent();

#ifdef USE_WINAPI
	extern HINSTANCE hinst;
#endif

	class Frame
	{
	public:
		Frame();
		virtual ~Frame();
	};
}
}


#endif
